#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "shoot2five4search.py">
#<abstract4xi abstract = "shoots to direction five"/>
#<refer4xi reference = "analyse2photo4search.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'shoot2five4search']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 


#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI   
try:    
    from dummyprocess4xi import DummyProcess4Xi
except:
    print("*** gun2five4search: *** error: from dummyprocess4xi import DummyProcess4Xi ***")
    
try:    
    from process4xi import Process4Xi
except:
    print("*** gun2five4search: *** error: from process4xi import Process4Xi ***")    
     
from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global base2build4five

global count2ack4five
global count2nack4five
global count2found4five
global count2short4five

global current2series4five
global candidate2series4five

global fileobject4five  

global keys2profile4five
global key2profile4five

global left2find4five

global maxsize2ack4five    
global maxsize2file4five 
global max2short4five
global meansize2ack4five
global minsize2ack4five

global five2analyse4search

global profile2fetch4five

global right2find4five

global sumsize2ack4five    

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
base2build4five = VersionKB4Xi['base2shoot4five']             # base internet address, None=local url

count2ack4five   = 0
count2nack4five  = 0
count2found4five = 0
count2short4five = 0

left2find4five = '('

max2short4five = VersionKB4Xi['max2short4five']
maxsize2file4five = VersionKB4Xi['maxsize2file4five']
maxsize2ack4five  = 0
meansize2ack4five = 0
minsize2ack4five  = 0

current2series4five = "current2series4five5dummy"
candidate2series4five  = "candidate2series4five5dummy"


five2analyse4search  = VersionKB4Xi['five2analyse4search']

profile2fetch4five = {}
profile2fetch4five [1] = '.JPG'                             # object types to be aceepted for hyperlinks
profile2fetch4five [2] = '.jpg'
keys2profile4five = profile2fetch4five.keys()

right2find4five = ')'

sumsize2ack4five  = 0

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "build2hyperlink4five" usage = "
#   builds hyperlinks
#"> 
# -------------------------------------------------------------------------------------------------
def build2hyperlink4five(target2explore4five):
    global count2ack4five
    global count2nack4five
    global count2found4five
    global count2short4five
    
    global fileobject4five 
       
    global keys2profile4five
    global key2profile4five
    
    global left2find4five

    global max2short4five    
    global maxsize2file4five     
    global maxsize2ack4five    
    global meansize2ack4five
    global minsize2ack4five
  
    global candidate2series4five
    global current2series4five
    
    
    global profile2fetch4five                         # extension for files
    
    global right2find4five
    
    global sumsize2ack4five    

       
    # ---------------------------------------------------------------------------------------------
    # INITIALIZE
    # ---------------------------------------------------------------------------------------------      
    count2found4five = count2found4five + 1
    ack2debug4five = False                            # <-- True
 
    # ---------------------------------------------------------------------------------------------
    # SPLIT TARGET NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2target=os.path.splitext(target2explore4five)
    
    ack2profile = False
    for key2profile4five in keys2profile4five:
        if name2target[1] == profile2fetch4five[key2profile4five]:                                                             
            ack2profile = True
    
    if ack2profile is True:     
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF SHOOT2FIVE4SEARCH - TARGET
        # -----------------------------------------------------------------------------------------
        path2input = target2explore4five
        if ack2debug4five is True:
            print("(STEP 0A/33) OF SHOOT2FIVE4SEARCH - PATH2INPUT: ", path2input) 
            #  
        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF SHOOT2FIVE4SEARCH - CHECK FILE STATUS
        # -----------------------------------------------------------------------------------------
        status2file = os.stat(path2input)
        size2file = status2file.st_size
        if size2file > maxsize2file4five:
            count2nack4five = count2nack4five + 1
        else:
            count2ack4five = count2ack4five + 1
            sumsize2ack4five = sumsize2ack4five + size2file
            if size2file > maxsize2ack4five:
                maxsize2ack4five = size2file
            if ((size2file < minsize2ack4five) or (minsize2ack4five == 0)):
                print("(STEP 0B/33) OF SHOOT2FIVE4SEARCH - USING MINSIZE2ACK4FIVE: ", minsize2ack4five, " SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # USING MINSIZE2ACK4FIVE:  0  SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2five//d\fivefly29july2012\fivefly29july2012 (1).JPG 
                # USING MINSIZE2ACK4FIVE:  3866624  SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2five//d\fivefly29july2012\fivefly29july2012 (2).JPG
                minsize2ack4five = size2file
                print("(STEP 0C/33) OF SHOOT2FIVE4SEARCH - SET MINSIZE2ACK4FIVE TO: ", minsize2ack4five, " = SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # SET MINSIZE2ACK4FIVE TO:  3866624  = SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2five//d\fivefly29july2012\fivefly29july2012 (1).JPG
                # SET MINSIZE2ACK4FIVE TO:  3538944  = SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2five//d\fivefly29july2012\fivefly29july2012 (2).JPG
                            
        # ==========================================================================================================
        # create hyperlink to image
        # ==========================================================================================================
        try:
            url2web4five = target2explore4five
            if ack2debug4five is True:print("(STEP 1A/33) OF SHOOT2FIVE4SEARCH - URL2WEB4FIVE: ", url2web4five) 
                # 
            
            ack2all4web = False
            string2edit = '\\'
            string2use = '/'
            while 1:
                if ack2all4web is True:
                    break
                else:
                    index2edit=str.find(url2web4five,string2edit)   
                    if index2edit == -1:
                        ack2all4web = True
                    else:
                        url2web4five = url2web4five[0:index2edit] + string2use + url2web4five[index2edit+1:]
                        
            name2web=os.path.splitext(url2web4five)
            shortname2web4five = name2web[0]
            if ack2debug4five is True:
                print("(STEP 1B/33) OF SHOOT2FIVE4SEARCH - SHORTNAME2WEB4FIVE: ", shortname2web4five)
                # 
            
            string2find4five = '/'
            ackall2found4five = False           
            while 1:
                if ackall2found4five is True:
                    break
                else:
                    index2find4five=str.find(shortname2web4five,string2find4five)   
                    if index2find4five == -1:
                        ackall2found4five = True
                    else:
                        shortname2web4five = shortname2web4five[index2find4five+1:]
                        
            if ack2debug4five is True:            
                print("(STEP 1C/33) OF SHOOT2FIVE4SEARCH - SHORTNAME2WEB4FIVE: ", shortname2web4five)
                # 
                
            ackall2found4five = False 
            while 1:
                if ackall2found4five is True:
                    break
                else:
                    index2left4five=str.find(shortname2web4five,left2find4five)
                    if index2left4five == -1:
                        current2series4five = shortname2web4five
                        if ack2debug4five is True:
                            print("(STEP 2A/33) OF SHOOT2FIVE4SEARCH - CURRENT2SERIES4FIVE: ", current2series4five) 
                            # 
                        ackall2found4five = True
                         
                    else:
                        index2right4five=str.find(shortname2web4five,right2find4five)
                        if index2right4five == -1:
                            ackall2found4five = True 
                        else:
                            candidate2series4five = shortname2web4five[0:index2left4five]
                            
                            index3find4five=str.find(shortname2web4five,current2series4five)
                            if index3find4five == -1:
                                
                                current2series4five = candidate2series4five
                                if ack2debug4five is True:
                                    print("(STEP 2B/33) OF SHOOT2FIVE4SEARCH - CURRENT2SERIES4FIVE: ", current2series4five) 
                                    # 
                                
                                count2short4five = 0
                                fileobject4five.write('<br />' + '\n')
                            else:
                                shortname2web4five = shortname2web4five[index2left4five:index2right4five+1]
                                if ack2debug4five is True:
                                    print("(STEP 2C/33) OF SHOOT2FIVE4SEARCH - SHORTNAME2WEB4FIVE: ", shortname2web4five)
                                    # 
                                
                                count2short4five = count2short4five + 1
                                if count2short4five >= max2short4five:
                                    count2short4five = 0
                                else:
                                    pass       
                            ackall2found4five = True
   
                                  
            # =======================================================================================================================
            # 
            # =======================================================================================================================                    
            if base2build4five is None:
                # ===================================================================================================================
                # LOCAL URL
                # ===================================================================================================================
                fileobject4five.write('<br /><b>&raquo;</b><a href="' + url2web4five + '" target="_blank">' + shortname2web4five + '</a>\n')                       
                
            else:
                # ===================================================================================================================
                # WEB URL
                # ===================================================================================================================            
                base2local4five = five2analyse4search
                if ack2debug4five is True:
                    print("(STEP 3A/33) OF SHOOT2FIVE4SEARCH - BASE2LOCAL4FIVE: ", base2local4five)
                    #              
                ack2localtries4five = False                   
                while 1:
                    if ack2localtries4five is True:
                        break
                    else:
                        index2find4five=str.find(url2web4five,base2local4five)            
                        # 
                        #  
                        if index2find4five == -1:
                            ack2localtries4five = True
                        else:
                            if ack2debug4five is True:
                                print("(STEP 3B/33) OF SHOOT2FIVE4SEARCH - BASE2BUILD4FIVE: ", base2build4five)
                                # 
                            url2web4five = base2build4five + url2web4five[len(base2local4five):]
                            if ack2debug4five is True:
                                print("(STEP 3C/33) OF SHOOT2FIVE4SEARCH - URL2WEB4FIVE: ", url2web4five)
                                # 
                            
                            if count2short4five < 1: 
                                fileobject4five.write('<br /><b>&raquo;</b><a href="' + url2web4five + '" target="_blank">' + shortname2web4five + '</a>' + '\n')
                            else:
                                fileobject4five.write('<b>&raquo;</b><a href="' + url2web4five + '" target="_blank">' + shortname2web4five + '</a>\n')                            
                            ack2localtries4five = True 
                        
        except:
            print("(Step 4Z1/33 OF SHOOT2FIVE4SEARCH FAILED, FILEOBJECT4FIVE-WRITE-FAILED: ", str(fileobject4five), time4xi())
      
    else:
        
        count2nack4five = count2nack4five + 1
        
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "shoot2five4search" usage = "analysing content">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def shoot2five4search(queue2five = None, consumer_channel2five = None, publisher_channel2five = None, path2five = None):
    '''
    communicates via the given queue and named pipe channels if multiprocessing4xi is being used 
    '''
    global count2ack4five
    global count2nack4five
    global count2found4five
    
    global fileobject4five    
    
    global maxsize2ack4five    
    global meansize2ack4five
    global minsize2ack4five
    global sumsize2ack4five    
    
    global maxsize2file4five 
    
    global profile2fetch4five                         # extension for files
    global keys2profile4five
    global key2profile4five

        
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    print("(STEP 0A/33) OF SHOOT2FIVE4SEARCH - STARTED TIME: ", time2start)   
    # 
    print("(STEP 0B/33) OF SHOOT2FIVE4SEARCH -  QUEUE2FIVE: ", queue2five)      
    # QUEUE2FIVE:  <queue4xi.Queue4Xi object at 0x02A5D930>
    
    print("(STEP 0C/33) OF SHOOT2FIVE4SEARCH -  CONSUMER_CHANNEL2FIVE: ", consumer_channel2five)
    # CONSUMER_CHANNEL2FIVE:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
          
    print("(STEP 0D/33) OF SHOOT2FIVE4SEARCH -  PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)          
    # PUBLISHER_CHANNEL2FIVE:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>

    if ((queue2five is None) or (consumer_channel2five is None) or (publisher_channel2five is None)):
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED
        # -----------------------------------------------------------------------------------------
        print("(STEP 1A/33) OF SHOOT2FIVE4SEARCH - COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED")
        print("(STEP 1B/33) OF SHOOT2FIVE4SEARCH - QUEUE2FIVE: ", queue2five)
        print("(STEP 1C/33) OF SHOOT2FIVE4SEARCH - CONSUMER_CHANNEL2FIVE: ", consumer_channel2five) 
        print("(STEP 1D/33) OF SHOOT2FIVE4SEARCH - PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)
        print("(STEP 1E/33) OF SHOOT2FIVE4SEARCH - PATH2FIVE: ", path2five)     
        
        return
 
    if (not (queue2five is None) and not(consumer_channel2five is None) and not(publisher_channel2five is None) and (path2five is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL (CC) MECHANISM OK, BUT PATH MISSING - CAN BE USED FOR TESTING CC 
        # -----------------------------------------------------------------------------------------
        print("(STEP 2A/33) OF SHOOT2FIVE4SEARCH - COMMAND AND CONTROL MECHANISM OK, BUT PATH MISSING")                       
        print("(STEP 2B/33) OF SHOOT2FIVE4SEARCH - QUEUE2FIVE: ", queue2five)
        print("(STEP 2C/33) OF SHOOT2FIVE4SEARCH - CONSUMER_CHANNEL2FIVE: ", consumer_channel2five) 
        print("(STEP 2D/33) OF SHOOT2FIVE4SEARCH - PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)
        print("(STEP 2E/33) OF SHOOT2FIVE4SEARCH - PATH2FIVE: ", path2five)     
        return           

    if (not (queue2five is None) and not(consumer_channel2five is None) and not(publisher_channel2five is None) and not(path2five is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN - PRODUCTION VERSION
        # -----------------------------------------------------------------------------------------
        print("(STEP 3A/33) OF SHOOT2FIVE4SEARCH - COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN")                       
        
        print("(STEP 3B/33) OF SHOOT2FIVE4SEARCH - QUEUE2FIVE: ", queue2five)
        # QUEUE2FIVE:  <queue4xi.Queue4Xi object at 0x02A5D930>
         
        print("(STEP 3C/33) OF SHOOT2FIVE4SEARCH - CONSUMER_CHANNEL2FIVE: ", consumer_channel2five)
        # CONSUMER_CHANNEL2FIVE:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
        print("(STEP 3D/33) OF SHOOT2FIVE4SEARCH - PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)
        # PUBLISHER_CHANNEL2FIVE:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>
        print("(STEP 3E/33) OF SHOOT2FIVE4SEARCH - PATH2FIVE: ", path2five)
        # PATH2FIVE:  F://temp//yophotos//test2five//
       
        print("(STEP 4A/33) OF SHOOT2FIVE4SEARCH - STARTING TO WALK PATH2FIVE: ", path2five)   
        # STARTING TO WALK PATH2FIVE:  F://temp//yophotos//test2five//
        
        # ==========================================================================================================
        # DYNAMICALLY BUILD HTML FILE USING SUBDIRECTORIES
        # ==========================================================================================================
        path2index4five = None
        try:
            name2index4five = "index2xxxxxxxx4yo.html"
            path2index4five = path2five + name2index4five
            print("(Step 4B/33) OF SHOOT2FIVE4SEARCH - SET PATH2INDEX4FIVE TO: ", path2index4five)
            # R://temp//yophotos//test//index2xxxxxxxx4yo.html
        except:
            print("(Step 4Z1/33) OF SHOOT2FIVE4SEARCH *** FAILED TO INITIALIZE PATH2INDEX4FIVE: ", path2index4five)          
            #                    
        fileobject4five = None
        try:
            fileobject4five = open(path2index4five,'w')
            print("(Step 4C/33) OF SHOOT2FIVE4SEARCH - OPENED OUTPUT: ", fileobject4five)
            # SHOOT2FIVE4SEARCH - OPENED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2five//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>
        except:
            print("(Step 4Z2/33) OF SHOOT2FIVE4SEARCH *** FAILED TO OPEN OUTPUT: ", fileobject4five)         
            # 
        try:                
            fileobject4five.write('<html>\n')
            
            fileobject4five.write('<style type="text/css" media="all">\n')
            fileobject4five.write(' @import "http://www.yourfivexi.org/css/halongbay.css";\n')
            fileobject4five.write('</style> \n')
            fileobject4five.write('<p>\n')
            fileobject4five.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4five.write('<br /><a id="000">yourfive<b>&Xi;</b> @Content</a>\n')
            fileobject4five.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4five.write('<br /> \n')

        except:
            print("(Step 4Z3/33) OF SHOOT2FIVE4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4five)         
            #      
        
        
        KB2name4five = {}
        key2name4five = 0
                 
        for file2walk in DirectoryWalker(path2five):
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------     
            if os.path.isdir(file2walk):
                try:    
                    KB2name4five [key2name4five] = file2walk
                    print ("KB2NAME4FIVE[", key2name4five, "]: ", KB2name4five [key2name4five])
                    # 
                    
                    key2name4five = key2name4five + 1

                except:
                    print ("(Step 4Z1/33) OF SHOOT2FIVE4SEARCH - FAILED UPDATING KB2NAME4FIVE WITH FILE2WALK: " + file2walk + '\n')     
            else:
                build2hyperlink4five(file2walk)
        
        # --------------------------------------------------------------------------------------------- 
        # END
        # --------------------------------------------------------------------------------------------- 
        try:
            fileobject4five.write('<br /> \n')
            fileobject4five.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4five.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4five.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /> \n')
            fileobject4five.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4five.write('<br />Small & Smart Inc reserves rights to change this document without any notice\n')
            fileobject4five.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4five.write('</p>\n')
            # 
            fileobject4five.write('</html>\n')
        except:
            print("(Step 4Z4/33) OF SHOOT2FIVE4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4five)         
            #            
        try:    
            fileobject4five.close()
            print("(Step 4C/33) OF SHOOT2FIVE4SEARCH - CLOSED OUTPUT: ", fileobject4five)         
            # SHOOT2FIVE4SEARCH - CLOSED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2five//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>   
        except:
            print("(Step 4Z5/33) OF SHOOT2FIVE4SEARCH *** FAILED TO CLOSE OUTPUT: ", fileobject4five)         
            #                  
                
                
        print("(STEP 5A/33) OF SHOOT2FIVE4SEARCH - STARTING TO ANALYSE KB2NAME4FIVE: ", time4xi())
        # STARTING TO ANALYSE KB2NAME4FIVE:  11:44:16 01/20/15 FLE Standard Time
        
        AlphaKB4five  = {}
        AlphaKB4five['a'] = {}
        AlphaKB4five['b'] = {}
        AlphaKB4five['c'] = {}
        AlphaKB4five['d'] = {}
        AlphaKB4five['e'] = {}
        AlphaKB4five['f'] = {}
        AlphaKB4five['g'] = {}
        AlphaKB4five['h'] = {}
        AlphaKB4five['i'] = {}
        AlphaKB4five['j'] = {}
        AlphaKB4five['k'] = {}
        AlphaKB4five['l'] = {}
        AlphaKB4five['m'] = {}
        AlphaKB4five['n'] = {}
        AlphaKB4five['o'] = {}
        AlphaKB4five['p'] = {}
        AlphaKB4five['q'] = {}
        AlphaKB4five['r'] = {}
        AlphaKB4five['s'] = {}
        AlphaKB4five['t'] = {}
        AlphaKB4five['u'] = {}
        AlphaKB4five['v'] = {}
        AlphaKB4five['w'] = {}
        AlphaKB4five['x'] = {}
        AlphaKB4five['y'] = {}
        AlphaKB4five['z'] = {} 
        keys2AlphaKB4five = AlphaKB4five.keys()
        key2AlphaKB4five  = 0
        
        
        # LEVELS FOR PATH
        KB2level1 = {}
        KB2level2 = {}
        KB2level3 = {}
        KB2level4 = {}
        KB2level5 = {}
        KB2level6 = {}
        KB2level7 = {}
        KB2level8 = {}
        
        key2level1 = 0
        key2level2 = 0
        key2level3 = 0
        key2level4 = 0
        key2level5 = 0
        key2level6 = 0
        key2level7 = 0
        key2level8 = 0
        
        len2cut4five = len(path2five)
        # 
        
        keys2name4five = KB2name4five.keys()
                
        for key2name4five in sorted(keys2name4five):
            # 
            name2optimize4five = KB2name4five[key2name4five]
            # 
            shortcut2level4five = name2optimize4five[len2cut4five:]
            # 
            len2shortcut4five = len(shortcut2level4five)
            if len2shortcut4five == 1:
                try:
                    # LEVEL FIVE CONSISTS OF ALPHABETIC FOLDERS A ... Z
                    if shortcut2level4five in keys2AlphaKB4five:
                        KB2level1[key2level1] = shortcut2level4five
                        # 
                        key2level1 = key2level1 + 1
                    else:
                        print ("(Step 5Z1/33) OF SHOOT2FIVE4SEARCH ** WARNING - SHORTCUT2LEVEL4FIVE: ", shortcut2level4five, " NOT IN KEYS2ALPHAKB4FIVE: ", keys2AlphaKB4five)
                except:
                        print ("(Step 5Z2/33) OF SHOOT2FIVE4SEARCH *** FAILED - SHORTCUT2LEVEL4FIVE: ", shortcut2level4five)      
            else:
                try:
                    
                    string2search4five = '\\'
                    shortcut2level4five = shortcut2level4five[2:]
                    
                    index2level4five=str.find(shortcut2level4five,string2search4five)
                    if index2level4five == -1:
                         
                        KB2level2[key2level2] = shortcut2level4five
                        key2level2 = key2level2 + 1
                    else:    
                        shortcut2level4five = shortcut2level4five[index2level4five+1:]
                        index2level4five=str.find(shortcut2level4five,string2search4five)
                        if index2level4five == -1:
                            KB2level3[key2level3] = shortcut2level4five
                            key2level3 = key2level3 + 1
                        else:
                            shortcut2level4five = shortcut2level4five[index2level4five+1:]
                            index2level4five=str.find(shortcut2level4five,string2search4five)
                            if index2level4five == -1:
                                KB2level4[key2level4] = shortcut2level4five
                                key2level4 = key2level4 + 1
                            else:
                                shortcut2level4five = shortcut2level4five[index2level4five+1:]
                                index2level4five=str.find(shortcut2level4five,string2search4five)
                                if index2level4five == -1:
                                    KB2level5[key2level5] = shortcut2level4five
                                    key2level5 = key2level5 + 1
                                else: 
                                    shortcut2level4five = shortcut2level4five[index2level4five+1:]
                                    index2level4five=str.find(shortcut2level4five,string2search4five)
                                    if index2level4five == -1:
                                        KB2level6[key2level6] = shortcut2level4five
                                        key2level6 = key2level6 + 1
                                    else:
                                        shortcut2level4five = shortcut2level4five[index2level4five+1:]
                                        index2level4five=str.find(shortcut2level4five,string2search4five)
                                        if index2level4five == -1:
                                            KB2level7[key2level7] = shortcut2level4five
                                            key2level7 = key2level7 + 1
                                        else:
                                            shortcut2level4five = shortcut2level4five[index2level4five+1:]
                                            index2level4five=str.find(shortcut2level4five,string2search4five)
                                            if index2level4five == -1:
                                                KB2level8[key2level8] = shortcut2level4five
                                                key2level8 = key2level8 + 1                
                                            else:
                                                print ("(Step 5Z2/33) OF SHOOT2FIVE4SEARCH ** WARNING: MOTE THAN 8 LEVELS, SHORTCUT2LEVEL4FIVE: ", shortcut2level4five)
                except:
                    print ("(Step 5Z3/33) OF SHOOT2FIVE4SEARCH *** FAILED - SHORTCUT2LEVEL4FIVE: ", shortcut2level4five)   
        
        print ("(Step 6A/33) OF SHOOT2FIVE4SEARCH - TRYING TO PRINT KB2level1 ", time4xi())       
        # SHOOT2FIVE4SEARCH - TRYING TO PRINT KB2level1  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level1 = KB2level1.keys()
            for key2Level1 in sorted(keys2Level1):
                print (KB2level1[key2Level1])      
                # a ... z          
        except:
            print ("(Step 6Z1/33) OF SHOOT2FIVE4SEARCH *** FAILED TO PRINT KB2level1 ", time4xi())    

        print ("(Step 6B/33) OF SHOOT2FIVE4SEARCH - TRYING TO PRINT KB2level2 ", time4xi())        
        # SHOOT2FIVE4SEARCH - TRYING TO PRINT KB2level2  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level2 = KB2level2.keys()
            for key2Level2 in sorted(keys2Level2):
                print (KB2level2[key2Level2])      
                # fivefly29july2012    
        except:
            print ("(Step 6Z2/33) OF SHOOT2FIVE4SEARCH *** FAILED TO PRINT KB2level2 ", time4xi()) 
            
        print ("(Step 6C/33) OF SHOOT2FIVE4SEARCH - TRYING TO PRINT KB2level3 ", time4xi())       
        try:
            keys2Level3 = KB2level3.keys()
            for key2Level3 in sorted(keys2Level3):
                print (KB2level3[key2Level3])      
                # 
        except:
            print ("(Step 6Z3/33) OF SHOOT2FIVE4SEARCH *** FAILED TO PRINT KB2level3 ", time4xi())             
        
        print ("(Step 6D/33) OF SHOOT2FIVE4SEARCH - TRYING TO PRINT KB2level4 ", time4xi())       
        # 
        try:
            keys2Level4 = KB2level4.keys()
            for key2Level4 in sorted(keys2Level4):
                print (KB2level4[key2Level4])      
                #            
        except:
            print ("(Step 6Z4/33) OF SHOOT2FIVE4SEARCH *** FAILED TO PRINT KB2level4 ", time4xi())                                         
        
        print ("(Step 6E/33) OF SHOOT2FIVE4SEARCH - TRYING TO PRINT KB2level5 ", time4xi())       
        # 
        try:
            keys2Level5 = KB2level5.keys()
            for key2Level5 in sorted(keys2Level5):
                print (KB2level5[key2Level5])      
                #              
        except:
            print ("(Step 6Z5/33) OF SHOOT2FIVE4SEARCH *** FAILED TO PRINT KB2level5 ", time4xi())             
        
        print ("(Step 6F/33) OF SHOOT2FIVE4SEARCH - TRYING TO PRINT KB2level6 ", time4xi())       
        # 
        try:
            keys2Level6 = KB2level6.keys()
            for key2Level6 in sorted(keys2Level6):
                print (KB2level6[key2Level6])      
                #              
        except:
            print ("(Step 6Z6/33) OF SHOOT2FIVE4SEARCH *** FAILED TO PRINT KB2level6 ", time4xi())             
    
        print ("(Step 6G/33) OF SHOOT2FIVE4SEARCH - TRYING TO PRINT KB2level7 ", time4xi())       
        # 
        try:
            keys2Level7 = KB2level7.keys()
            for key2Level7 in sorted(keys2Level7):
                print (KB2level7[key2Level7])      
                #              
        except:
            print ("(Step 6Z7/33) OF SHOOT2FIVE4SEARCH *** FAILED TO PRINT KB2level7 ", time4xi()) 
            
        print ("(Step 6H/33) OF SHOOT2FIVE4SEARCH - TRYING TO PRINT KB2level8 ", time4xi())       
        # 
        try:
            keys2Level8 = KB2level8.keys()
            for key2Level8 in sorted(keys2Level8):
                print (KB2level8[key2Level8])      
                #              
        except:
            print ("(Step 6Z8/33) OF SHOOT2FIVE4SEARCH *** FAILED TO PRINT KB2level8 ", time4xi())         
        
        print ("(Step 7A/33) OF SHOOT2FIVE4SEARCH - TRYING TO PRINT STATISTICS ", time4xi())   
        #     
        try:    
            print ("(Step 7B/33) OF SHOOT2FIVE4SEARCH - COUNT2ACK4FIVE; ", count2ack4five)
            # COUNT2ACK4FIVE;  3 <-- *.jpg
            print ("(Step 7C/33) OF SHOOT2FIVE4SEARCH - COUNT2NACK4FIVE; ", count2nack4five)
            # COUNT2NACK4FIVE;  2 <-- index.html
            print ("(Step 7D/33) OF SHOOT2FIVE4SEARCH - COUNT2FOUND4FIVE: ", count2found4five)
            # COUNT2FOUND4FIVE:  5 <-- all files
        except:
             print ("(Step 7Z1/33) OF SHOOT2FIVE4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:  
            print ("(Step 7E/33) OF SHOOT2FIVE4SEARCH - FOUND MAX SIZE: ", maxsize2ack4five)
            #  3866624
            print ("(Step 7F/33) OF SHOOT2FIVE4SEARCH - ALLOWED MAX SIZE: ", maxsize2file4five)
            # 33000000
        except:
             print ("(Step 7Z2/33) OF SHOOT2FIVE4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:         
            if count2found4five == 0:
                meansize2ack4five = 0
                print ("(Step 7G1/33) OF SHOOT2FIVE4SEARCH - MEAN SIZE SET: ", meansize2ack4five)
                #  
            else:       
                meansize2ack4five = int(sumsize2ack4five / count2ack4five)
                print ("(Step 7G2/33) OF SHOOT2FIVE4SEARCH - MEAN SIZE CALCULATED: ", meansize2ack4five, ", WHERE SUMSIZE2ACK4FIVE: ", sumsize2ack4five, " COUNT2ACK4FIVE: ", count2ack4five)
                # MEAN SIZE CALCULATED:  3648170 , WHERE SUMSIZE2ACK4FIVE:  10944512  COUNT2ACK4FIVE:  3 
        except:
             print ("(Step 7Z3/33) OF SHOOT2FIVE4SEARCH *** FAILED TO CALCULATE STATISTICS ", time4xi())
        
        try:                 
            if minsize2ack4five < maxsize2file4five:
                print ("(Step 7H/33) OF SHOOT2FIVE4SEARCH - MIN SIZE MET: ", minsize2ack4five)
                # 3538944
            else:
                print ("(Step 7I/33) OF SHOOT2FIVE4SEARCH ** MIN DEFINED: ", minsize2ack4five, " EQUALS TO MAXSIZE2FILE4FIVE: ", maxsize2file4five)        
        except:
             print ("(Step 7Z4/33) OF SHOOT2FIVE4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
             
                         
        print("(STEP 4Y/33) OF SHOOT2FIVE4SEARCH - RETURNING: ", time4xi(), " HAVING STARTED: ", time2start) 
        # 12:26:08 01/20/15 FLE Standard Time  HAVING STARTED:  12:26:08 01/20/15 FLE Standard Time
 
        
               
        return
    else:
        # -----------------------------------------------------------------------------------------
        # UNEXPECTED PARAMETER COMBINATION - ERROR
        # -----------------------------------------------------------------------------------------
        print("(STEP 7Z1/33) OF SHOOT2FIVE4SEARCH *** ERROR IN LOGIC ***")
        print("(STEP 7Z2/33) OF SHOOT2FIVE4SEARCH - QUEUE2FIVE: ", queue2five)
        print("(STEP 7Z3/33) OF SHOOT2FIVE4SEARCH - CONSUMER_CHANNEL2FIVE: ", consumer_channel2five) 
        print("(STEP 7Z4/33) OF SHOOT2FIVE4SEARCH - PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)
        print("(STEP 7Z5/33) OF SHOOT2FIVE4SEARCH - PATH2FIVE: ", path2five)     
              
        return  
            
               
#</function4xi>


#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# ROOT4XI\Studio4Xi\Python\3.3\txt\analyse2photo4search.txt
# \xml\ace-analyse2photo.xml
# \xml\reason-analyse2photo.xml
# \xml\sense-analyse2photo.xml
# 
#"
#>
  

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.fivexi.com; www.yourfivexi.com; www.yourfivexi.org; www.five2xi.com/; www.five4xi.com/; www.five8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of shoot2five4search.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
